import Live
from PhotonX25Component import PhotonX25Component

from consts import *

class PhotonX25TransportController(PhotonX25Component):
	__module__ = __name__
	__doc__ = "Transport Controller for PhotonX25 remote control surface"
	__filter_funcs__ = ["update_display", "log"]

	def __init__(self, parent):
		PhotonX25Component.realinit(self, parent)

	def build_midi_map(self, script_handle, midi_map_handle):
		def forward_cc(chan, cc):
			Live.MidiMap.forward_midi_cc(script_handle, midi_map_handle, chan, cc)
		def forward_note(chan, note_no):
			Live.MidiMap.forward_midi_note(script_handle, midi_map_handle, chan, note_no)

		for channel in BTN_CHANNELS:
			for cc_no in TRANSPORT_BTNS:
				forward_cc(channel, cc_no)


	def receive_midi_note(self, channel, status, note_no, note_vel):
		pass


	def receive_midi_cc(self, channel, cc_no, cc_value):
		if(channel in BTN_CHANNELS and cc_no in TRANSPORT_BTNS):
			if(cc_no == PLAY and cc_value == BTN_ON):
				self.parent.song().is_playing =(not self.parent.song().is_playing)
			elif(cc_no == RECORD and cc_value == BTN_ON):
				#if(cc_value==BTN_ON):
				if(self.parent.song().record_mode == 0):
					self.parent.song().record_mode = 1
				else:
					self.parent.song().record_mode = 0
			elif(cc_no == OVERDUB and cc_value == BTN_ON):
				#if(cc_value==BTN_ON):
				if(self.parent.song().overdub == 0):
					self.parent.song().overdub = 1
				else:
					self.parent.song().overdub = 0
			#elif(cc_no == STOP):
			# notused atm. would like to map it the tap function


		

	def disconnect(self):
		pass
	