
# author : mots@motscousus.com

######################################################################
#
# MAP REAL LIFE CCS TO MORE HUMAN READABLE THINGS
#
# IF YOUR NOTE NUMBER ON YOUR MPD16 
# ARE NOT THE DEFAULT ONES CHANGE THEM BELOW
#
# on my photon knobs have cc ranging from 101 to 110
# from the first row left to right, then second row
# layer one is on channel 11
# layer one is on channel 12
# layer one is on channel 13
#
# buttons are on CC 101 to 110
# buttons are  on channel 14
#
# you can change these, but all the buttons 
# must on the same midi channel.
# also all the knobs of on layer must be on the same layer
# knobs must have the same cc number in each layer  
# and must on different channel
#
# real life MIDI channels 1-16 are mapped to 0-15 in live python scripts
#
######################################################################

# KNOBS
# knobs are supposed to have the same cc number
# on each layer, there we enter them here only once
KNOB_1=101
KNOB_2=102
KNOB_3=103
KNOB_4=104
KNOB_5=105
KNOB_6=106
KNOB_7=107
KNOB_8=108
KNOB_9=109
KNOB_10=110

# list of knobs
KNOBS = [KNOB_1,KNOB_2,KNOB_3,KNOB_4,KNOB_5,KNOB_6,KNOB_7,KNOB_8,KNOB_9,KNOB_10]

#  used to map the first row for something 
#  (volume for instance in the 1st layer)
#  and the 2nd for something else (panning in the first layer)
UPPER_SEMI_LAYER=[KNOB_1,KNOB_2,KNOB_3,KNOB_4,KNOB_5]
LOWER_SEMI_LAYER=[KNOB_6,KNOB_7,KNOB_8,KNOB_9,KNOB_10]


# LAYER OF KNOBS
#  the -1 is here to map reallife midichannels [1-16]
#  to midi channels seen from a programming point [0-15]
#  you can put more than one channels separated by commas
LAYER_A_CHANNELS=[11 -1] # volume, pan
LAYER_B_CHANNELS=[12 -1] # send A, send B
LAYER_C_CHANNELS=[13 -1] # selected device (fx,intru,rack) control


# BUTTONS
BTN_1=101  
BTN_2=102  
BTN_3=103  
BTN_4=104  
BTN_5=105  
BTN_6=106  
BTN_7=107  
BTN_8=108  
BTN_9=109  
BTN_10=110 

#  the "-1" is here to map reallife midichannels [1-16]
#  to midi channels seen from a programming point [0-15]
#  you can put more than one channels separated by commas
BTN_CHANNELS=[14 -1]

# list of buttons
BTNS=[BTN_1,BTN_2,BTN_3,BTN_4,BTN_5,BTN_6,BTN_7,BTN_8,BTN_9,BTN_10]



######################################################################
#
# MAP OUR HUMAN READABLES NAMES TO FUNCTIONS
#
######################################################################

ARM_TRACK=BTN_6
MUTE_TRACK=BTN_7
SOLO_TRACK=BTN_8
PREV_TRACK	= BTN_1
NEXT_TRACK	= BTN_2
TRACK_BUTTONS=[ARM_TRACK,MUTE_TRACK,SOLO_TRACK,PREV_TRACK,NEXT_TRACK]
EXCLUSIVE_ARM=False

BANK_PREV	= BTN_1
BANK_NEXT	= BTN_2
BANK_BTNS=[]
BANK_WIDTH=1

STOP	= BTN_3
PLAY	= BTN_4
RECORD	= BTN_5
OVERDUB = BTN_3
TRANSPORT_BTNS=[OVERDUB,PLAY,RECORD]

#these should select the track in the active bank
# and recall the next track effect, but is doesn't due to
# missing function in the live API
# instead it just select the track and allows you
# to control the select device (using layer 3 knobs) on the track
FX1		= BTN_6
FX2		= BTN_7
FX3		= BTN_8
FX4		= BTN_9
FX5		= BTN_10
FX_BTNS = []


######################################################################
#
# USEFULL CONSTANTS
#
######################################################################


# MIDI STUFF

STATUS_MASK     = 0xF0
CHAN_MASK       = 0x0F

CC_STATUS	    = 0xb0
NOTEON_STATUS   = 0x90
NOTEOFF_STATUS  = 0x80

STATUS_ON       = 0x7f
STATUS_OFF      = 0x00
STATUS_OFF2     = 0x40
BTN_ON			= 127
BTN_OFF			= 0
